# $Id: Compartment.pm,v 1.1 2006/09/25 04:50:31 faeder Exp $

package Compartment;

use Class::Struct;
use FindBin;
use lib $FindBin::Bin;
use Expression;

struct Compartment => {
  Name=> '$',
  SpatialDimensions=> '$', # 0-3
  Size=>'Expression',      
  Outside=>'Compartment',  
};

sub adjacent {
  my $comp1=shift;
  my $comp2=shift;


  # Compartment 1 contains Compartment 2
  if ($comp2->Outside==$comp1){
    return(1);
  }

  # Compartment 2 contains Compartment 1
  if ($comp1->Outside==$comp2){
    return(-1);
  }

  return(0);
}

sub connected {
  my @nodes_conn= (shift);
  my @nodes_left= @_;

  my $link_found;
  while(@nodes_left){
    $link_found=0;
    for my $n1 (@nodes_conn){
      for my $i (0..$#nodes_left){
	if ($n1->adjacent($nodes_left[$i])){
	  push @nodes_conn, $nodes_left[$i];
	  splice @nodes_left, $i, 1;
	  $link_found=1;
	  last;
	}
      }
      last if $link_found;
    }
    last unless $link_found;
  }
  # Compartment graph is not connected unless link was found on last loop
  return($link_found)
}


sub toString{
  my $comp=shift;
  my $plist=(@_) ? shift : "";

  my $string="";

  $string.=$comp->Name;
  $string.=" ".$comp->SpatialDimensions;
  if ($plist){
    $string.=" ".$comp->Size->toString($plist);
  }
  if (my $ccomp=$comp->Outside){
    $string.=" ".$ccomp->Name;
  }
  return($string);
}

sub toXML{
  my $comp=shift;
  my $indent=shift;

  my $string=$indent."<Compartment";

  # Attributes
  # id
  $string.=" id=\"".$comp->Name."\"";
  # spatialDimensions
  $string.= " spatialDimensions=\"".$comp->SpatialDimensions."\"";
  # size
  $string.= " size=\"".$comp->Size->toString()."\"";
  # outside
  if ($comp->Outside){
    $string.= " outside=\"".$comp->Outside->Name."\"";
  }

  $string.="/>\n"; # short tag termination

  return($string);
}

1;
