# $Id: Rxn.pm,v 1.9 2007/07/06 04:46:32 faeder Exp $

package Rxn;

use Class::Struct;
use FindBin;
use lib $FindBin::Bin;
use BNGUtils;
use SpeciesGraph;

struct Rxn => {
  Reactants=> '@', # Array of reactant Species
  Products=>  '@', # Array of product Species
  RateLaw=>   'RateLaw',
  StatFactor=> '$',	       
  Priority=>   '$',
  RxnRule=>   '$'	       
};

sub toString{
  my $rxn= shift;
  my $text= (@_) ? shift : 0;
  my $plist= (@_) ? shift : 0;

  *reac= $rxn->Reactants;
  *prod= $rxn->Products;
  
  my $string;
  
  if ($text){
    my @rstrings=();
    my @pstrings=();
    for $r (@reac){
      push @rstrings, $r->SpeciesGraph->toString();
    }
    for $p (@prod){
      push @pstrings, $p->SpeciesGraph->toString();
    }
    $string= join(' + ', @rstrings)." -> ".join(' + ', @pstrings);
  } else { 
    $string= $rxn->stringID(); 
  }
  $string.= " ".$rxn->RateLaw->toString($rxn->StatFactor,1,$plist);
  if ($rxn->RxnRule){
    $string.= " #".$rxn->RxnRule->Name;
  }

  return($string);
}

# Used to compare whether reactions are identical (only in terms of species
# involved)
sub stringID{
  my $rxn= shift;

  *reac= $rxn->Reactants;
  *prod= $rxn->Products;
  my $string="";
  
  my @rstrings=();
  for $r (@reac){
    push @rstrings, $r->Index;
  }
  my @pstrings=();
  for $p (@prod){
    push @pstrings, $p->Index;
  }
  # print join(' ',@rstrings, @pstrings),"\n";
  
  my $type= $rxn->RateLaw->Type;

  if (($type eq "Ele") or ($type eq "Zero")){
    @rstrings= sort {$a<=>$b} @rstrings;
    @pstrings= sort {$a<=>$b} @pstrings;
  }
    
  $string.= join(',', @rstrings)." ".join(',', @pstrings);

  return($string);
}


1;
