#!/usr/bin/perl

$ordered=0;

while ($ARGV[0] =~ /^-/){
    $_ = shift;
    if (/^-n$/){
      $ordered=0;
    }
    else{
      die "Unrecognized command line option: $_";
    }
}

$file1= shift(@ARGV);
$file2= shift(@ARGV);

open(file1) || die "Couldn't open ${file1}: $!";
open(file2) || die "Couldn't open ${file2}: $!";

@spec1=();
READ1:
while(<file1>){
  next unless (/^begin species/);
  while(<file1>){
    last READ1 if /^end species/;
    ($index, $spec, $conc)= split(' ');
    push @spec1, $spec;
  }
}

@spec2=();
READ2:
while(<file2>){
  next unless (/^begin species/);
  while(<file2>){
    last READ2 if /^end species/;
    ($index, $spec, $conc)= split(' ');
    push @spec2, $spec;
  }
}

if ($#spec1 != $#spec2){
  printf "Incompatible number of species in two files: %d %d\n", scalar(@spec1), scalar(@spec2);
  exit(0);
}

if ($ordered){
  for $i (0..$#spec1){
    next if ($spec1[$i] eq $spec2[$i]);
    printf "Mismatch at species %d: %s %s\n", $i+1, $spec1[$i], $spec2[$i];
  }
} else {
  %spec1_names=();
  for $spec (@spec1){
    $spec1_names{$spec}=1;
  }  
  %spec2_names=();
  for $spec (@spec2){
    $spec2_names{$spec}=1;
  }  
  for $i (0..$#spec1){
    if (!defined($spec2_names{$spec1[$i]})){
      printf "No match for species %d of $file1: %s\n", $i+1, $spec1[$i];
    }
    if (!defined($spec1_names{$spec2[$i]})){
      printf "No match for species %d of $file2: %s\n", $i+1, $spec2[$i];
    }
  }
}
